// Programmed by Makhovikov Andrey
// Compiled using Borland C++ v3.1
//
#include <fstream.h>
#include <string.h>
#include <stdlib.h>
#include <dir.h>
#define YES 1
#define NO  0

int WRITE = NO;

void main(void)

{
// Info
   cout << "\n\n";
   cout << "Ŀ\n";
   cout << " Single-player Missions Extractor v.1.1 \n";
   cout << "Ĵ\n";
   cout << "      Written by Andrey Makhovikov      \n";
   cout << "  E-mail: makhovikov_andrey@mtu-net.ru  \n";
   cout << "      for Allods/Allods 2/RoM/RoM 2     \n";
   cout << "                                        \n";
   cout << "    FREEWARE - USE ON YOUR OWN RISK!    \n";
   cout << "Ĵ\n";
   cout << " Run this tool from your game directory \n";
   cout << "\n";

   ifstream input_file;
   ofstream output_file;
   unsigned char c;
   char filename[11];
   char filenumber[] = "01";
   int status = 0;

// Open source amd destination files
   input_file. open("scenario.res", ios::binary | ios::in | ios::nocreate);
   if (input_file. fail())
     {
	 cout << "\nNo SCENARIO.RES found. Terminating...\n";
	 exit(EXIT_FAILURE);
     }

   mkdir("MISSIONS");
   cout << "           \n";

   chdir("MISSIONS");
   cout << "Extracting in progress... ";
   
   for (long i = 0; ; i++)
     {
	 input_file. read(&c, 1);
	 if (input_file. eof()) break;
	 switch (status)
	   {
		case 0:	if (c == 'M') status++;
			break;
		case 1:	if (c == '7') status++; else status = 0;
			break;
		case 2:	if (c == 'R') status++; else status = 0;
			break;
		case 3: //cout << "Extracting mission " << filenumber << "\n";
			status = 0;

			strcpy(filename, "almap");
			strcpy(filename + 5, filenumber);
			strcpy(filename + 7, ".alm");

			if (strcmp(filenumber, "01"))
				output_file. close();	// close previous file

			if (filenumber[1] == '9')
				{
				   filenumber[1] = '0';
				   filenumber[0]++;
				}
			else filenumber[1]++;
			WRITE = YES;

			output_file. open(filename, ios::binary | ios::out);
			if (output_file. fail())
			     {
				 cout << "\nDestination file can not be created. Terminating...\n";
				 input_file. close();
				 exit(EXIT_FAILURE);
			     }
			output_file. write("M7R", 3);

	    }

// Check group identifier, 0x20 - the first group address...
	 if (WRITE == YES) output_file. write(&c, 1);
     }

   chdir("..");
   cout << "Done!\n";
   input_file. close();
   output_file. close();
   exit(EXIT_SUCCESS);
}